package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.*;
import java.net.*;
import java.util.ArrayList;

import org.greenstone.gsdl3.gs3build.metadata.*;

public class IndexRecogniser extends AbstractRecogniser
{
    
    public IndexRecogniser(DocumentList listRepository)
    { 
	this.preferred_mime_type = "text/plain";
	this.filename_extensions = new ArrayList();
	this.filename_extensions.add("index.txt");
	this.document_type = IndexDocument.INDEX_DOCUMENT_TYPE;
    }
    

    public boolean parseDocument(URL url)
    { 
	String filename = null;

	if (url.getProtocol().equals("file")) {
	    filename = url.getPath();
	}
	
	if (filename != null) {
	    String leafName;
	    int leafAt = filename.lastIndexOf(File.separator);
	    if (leafAt >= 0) {
		leafName = filename.substring(leafAt+1);
	    } else {
		leafName = filename;
	    }

	    if (leafName.equals("index.txt")) {
		
		System.out.println("Posting Index Document " + filename);
		IndexDocument doc = new IndexDocument(url);
		this.list_repository.addDocument(doc);
		// TODO: spawn knowledge of children too...
		//				System.out.println(doc.getDocumentText());
		return true;
	    }
	} else {
	    // TODO: get Mime type remotely, and then proceed if required
	}
	return false;
    }
}
